<template>
    <v-card class="w-[350px]">
        <LanguageSwitch />
        <Logo />

        <div class="space-y-4">
            <div>
                <h1 class="text-secondary text-xl leading-8 mb-2">
                    {{ translate('forgot_password.title') }}
                </h1>
                <p class="mb-8 text-sm">
                    {{ translate('forgot_password.description') }}
                </p>
            </div>

            <v-form ref="form" @submit.prevent="forgetPassword()">
                <v-text-field
                    v-model="email"
                    id="email"
                    :label="translate('labels.email')"
                    :rules="validator.setRules('required|email').validate()"
                    validate-on="submit"
                ></v-text-field>
            </v-form>
        </div>

        <div class="flex gap-2 justify-end mt-6">
            <v-btn :to="'authentication.login'" variant="outlined" color="secondary">
                {{ translate('global.buttons.back') }}
            </v-btn>
            <v-btn color="secondary" @click="forgetPassword">
                {{ translate('labels.submit') }}
            </v-btn>
        </div>
    </v-card>
</template>

<script lang="ts" setup>
import { ref, onMounted } from 'vue';
import { useRoute, useRouter } from 'vue-router';
import { useI18n } from 'vue-i18n';
import { storeFactory } from '@/main';

// Components
import Logo from '@/components/LogoImage.vue';
import LanguageSwitch from '@/components/language/LanguageSwitch.vue';

//Validator
import { Validator } from '@/helpers/Validator';

const { t: translate } = useI18n();
const router = useRouter();
const route = useRoute();
const email = ref('');
const form = ref(null) as any;
const validator = new Validator();

onMounted(() => {
    if (route.query.email) {
        email.value = route.query.email as string;
    }
});

const forgetPassword = async () => {
    if (!(await form.value.validate())?.valid) {
        return;
    }
    if (await storeFactory.userStore.resetPassword(email.value)) {
        await router.push({ name: 'dashboard.index' });
    }
};
</script>
